#include "gpio.h"
#include "ram.h"

#define ENABLE_LED_TX_GPIO_CLK      __HAL_RCC_GPIOE_CLK_ENABLE()
#define LED_TX_PIN                  GPIO_PIN_10
#define LED_TX_GPIO_PORT            GPIOE

#define ENABLE_LED_RX_GPIO_CLK      __HAL_RCC_GPIOE_CLK_ENABLE()
#define LED_RX_PIN                  GPIO_PIN_2
#define LED_RX_GPIO_PORT            GPIOE

#define ENABLE_LED_USR1_GPIO_CLK    __HAL_RCC_GPIOA_CLK_ENABLE()
#define LED_USR1_PIN                GPIO_PIN_13
#define LED_USR1_GPIO_PORT          GPIOA

#define ENABLE_LED_USR2_GPIO_CLK    __HAL_RCC_GPIOE_CLK_ENABLE()
#define LED_USR2_PIN                GPIO_PIN_9                
#define LED_USR2_GPIO_PORT          GPIOE

#define ENABLE_START_PB_GPIO_CLK    __HAL_RCC_GPIOE_CLK_ENABLE()
#define START_PB_PIN                GPIO_PIN_3
#define START_PB_GPIO_PORT          GPIOE
                       
#define ENABLE_MODE_PB_GPIO_CLK     __HAL_RCC_GPIOE_CLK_ENABLE()
#define MODE_PB_PIN                 GPIO_PIN_4
#define MODE_PB_GPIO_PORT           GPIOE
                       
#define ENABLE_RESET_PB_GPIO_CLK    __HAL_RCC_GPIOA_CLK_ENABLE()
#define RESET_PB_PIN                GPIO_PIN_12
#define RESET_PB_GPIO_PORT          GPIOA
                       
#define ENABLE_USER_PB_GPIO_CLK     __HAL_RCC_GPIOA_CLK_ENABLE()
#define USER_PB_PIN                 GPIO_PIN_11
#define USER_PB_GPIO_PORT           GPIOA

#define GPI_EXTI1_IRQn              EXTI15_10_IRQn
#define GPI_EXTI1_IRQHandler        EXTI15_10_IRQHandler

#define GPI_EXTI2_IRQn              EXTI4_IRQn
#define GPI_EXTI2_IRQHandler        EXTI3_IRQHandler

#define GPI_EXTI3_IRQn              EXTI4_IRQn
#define GPI_EXTI3_IRQHandler        EXTI4_IRQHandler

#define GPO_TIMER                   TIM2
#define ENABLE_GPO_TIMER_CLK        __HAL_RCC_TIM2_CLK_ENABLE()
#define GPO_TIMER_IRQn              TIM2_IRQn
#define GPO_TIMER_IRQHandler        TIM2_IRQHandler

// private variables

// IRQ handler functions
void GPI_EXTI1_IRQHandler(void)
{
}

void GPI_EXTI2_IRQHandler(void)
{
}

void GPI_EXTI3_IRQHandler(void)
{
}

void GPO_TIMER_IRQHandler(void)
{
}

// private functions

// public functions
void gpio_init(void)
{
}

void gpio_set_led(led_t led_id)
{
}

void gpio_clear_led(led_t led_id)
{
}

void gpio_toggle_led(led_t led_id)
{
}

void gpio_blink_led(led_t led_id, int16_t period_ms)
{
}

uint8_t gpio_is_pushbutton_pressed(pushbutton_t pb_id)
{
}

void gpio_set_pushbutton_callback(pushbutton_t pb_id,void (*callback)(void))
{
}
